"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DeliveryTask(ProtocolElement):
    """
    Defines a delivery task. A delivery task identifies an instance of the
    whole delivery     interaction cycle, whether successful or not.
    This allows traceability and identification     of failed
    deliveries
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "analysisType",
        "basePath",
        "protocolVersion",
        "tieringResultId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "analysisType": reports_4_2_0.AnalysisType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.AnalysisType": reports_4_2_0.AnalysisType,
            "org.gel.models.report.avro.DeliveryTask": reports_4_2_0.DeliveryTask,
        }

    __slots__ = [
        "analysisType",
        "basePath",
        "protocolVersion",
        "tieringResultId",
    ]

    def __init__(
        self,
        analysisType,
        basePath,
        protocolVersion,
        tieringResultId,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.DeliveryTask model.

        :param analysisType:
        :type analysisType: AnalysisType
        :param basePath:
            Base path on MDT storage where GEL should transfer files associated
            with the study
        :type basePath: str
        :param protocolVersion:
        :type protocolVersion: str
        :param tieringResultId:
            Unique id of the delivery task, linked to one TieringResult
        :type tieringResultId: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
